dashboard/urls.py
from django.urls import (
    path,
    re_path,
    include
)

from dashboard.views import HomeView

from accounts.views import (
    AccountProfileUpdateView,
    AccountProfileFinalizeView
)

from project.views import (
    ApplicationCreateView,
    ApplicationListView,
    ApplicationView,
    ApplicationFinalizeView,
    ProjectTemplateView,
    ProjectView,
    ProjectFinalizeView,
    ProjectShownView,
    TeamMemberView,
    TeamPublishedView
)


app_name = 'dashboard'

urlpatterns = [
    re_path(
        r'^$',
        HomeView.as_view(),
        name='home'
    ),
    re_path(
        r'^account/application/(?P<pk>\d+)/create/$',
        ApplicationCreateView.as_view(),
        name='application-create'
    ),
    re_path(
        r'^account/applications/$',
        ApplicationListView.as_view(),
        name='application-list'
    ),
    re_path(
        r'^account/application/(?P<sku>\w+\d*)/$',
        ApplicationView.as_view(),
        name='application-edit'
    ),
    re_path(
        r'^account/application/(?P<sku>\w+\d*)/published/$',
        ApplicationFinalizeView.as_view(),
        name='application-published'
    ),
    re_path(
        r'^account/application/(?P<sku>\w+\d*)/project/(?P<sku_project>\w+\d*)/preview/$',
        ProjectTemplateView.as_view(),
        name='project-view'
    ),
    re_path(
        r'^account/application/(?P<sku>\w+\d*)/project/(?P<sku_project>\w+\d*)/$',
        ProjectView.as_view(),
        name='application-project-edit'
    ),
    re_path(
        r'^account/application/(?P<sku>\w+\d*)/project/(?P<sku_project>\w+\d*)/published/$',
        ProjectFinalizeView.as_view(),
        name='application-project-published'
    ),
    re_path(
        r'^account/application/(?P<sku>\w+\d*)/project/(?P<sku_project>\w+\d*)/shown/$',
        ProjectShownView.as_view(),
        name='application-project-shown'
    ),
    re_path(
        r'^account/application/(?P<sku>\w+\d*)/project/(?P<sku_project>\w+\d*)/team/members/$',
        TeamMemberView.as_view(),
        name = 'project-team-member'
    ),
    re_path(
        r'^account/application/(?P<sku>\w+\d*)/project/(?P<sku_project>\w+\d*)/team/published/$',
        TeamPublishedView.as_view(),
        name = 'project-team-published'
    ),
    re_path(
        r'^account/profile/(?P<sku_app>\w+\d*)/$',
        AccountProfileUpdateView.as_view(),
        name='account-profile-edit'
    ),
    re_path(
        r'^account/profile/(?P<sku_app>\w+\d*)/published/$',
        AccountProfileFinalizeView.as_view(),
        name='account-profile-published'
    ),
]

pages/urls.py
from django.urls import path, re_path, include
from django.views.decorators.cache import cache_page
from . import views

app_name = 'pages'
urlpatterns = [
    re_path(r'^$', views.HomeView.as_view(), name='home'),
    re_path(r'^service/$', views.ServiceView.as_view(), name='service'),
    re_path(r'^about/$', views.AboutView.as_view(), name='about'),
    re_path(r'^contact/$', views.ContactView.as_view(), name='contact'),
    re_path(r'^portfolio/$', views.PortfolioView.as_view(), name='portfolio'),
    re_path(r'^portfolio/(?P<slug>[\w\-]+)/$', views.PortfolioDetailView.as_view(), name='project-detail'),
]

dashboard/models.py
from django.db import models

# Create your models here.

project/models.py
from project.submodels.application import Application
from project.submodels.project import Project
from project.submodels.reviews import Reviews
from project.submodels.team import Team
from project.submodels.member import Member

step/models.py
from django.db import models
from django.core.validators import MinLengthValidator
from django.core.validators import MaxLengthValidator
from django.utils.translation import ugettext_lazy as _
from django.utils.text import slugify
from django.conf import settings

from step.managers import StepManager

class Step(models.Model):
    SECTIONS =( 
        ("1", "Profile"), 
        ("2", "Application"), 
        ("3", "Project"), 
        ("4", "Team"), 
        ("5", "Preview"), 
        ("6", "Result"), 
    ) 
    STATES =( 
        ("t", "task"), 
        ("i", "in_Progress"), 
        ("c", "Complete"), 
    ) 

    user = models.ForeignKey(settings.AUTH_USER_MODEL,
                             verbose_name = _("User"),
                             related_name = 'steps',
                             on_delete = models.PROTECT
                            )

    state = models.CharField(max_length = 1, choices = STATES, validators=[MinLengthValidator(1), MaxLengthValidator(1)], default = 'i')
    step = models.CharField(max_length = 1, choices = SECTIONS, validators=[MinLengthValidator(1), MaxLengthValidator(1)], default = '1')

    application = models.ForeignKey('project.Application',
                                    verbose_name = _("Application"), 
                                    related_name = 'steps',
                                    on_delete = models.PROTECT,
                                    blank = True, null = True
                                   )

    created = models.DateTimeField(_("Created"), auto_now_add=True)
    modified = models.DateTimeField(_("Modified"), auto_now=True)

    objects = StepManager()

    class Meta:
        verbose_name = _('Step')
        verbose_name_plural = _('Steps')
        ordering = ('step',)

    def __str__(self):
        return f'<{self.state}>  <{self.user.username}>'

    def __repr__(self):
        return f'<{self.state}>  <{self.user.username}>'

dashboard/views.py
from django.views.generic import TemplateView

from django.contrib.auth.mixins import LoginRequiredMixin

from accounts.models import Profile

from project.models import (
    Application,
    Project
)

from ticket.models import Ticket

from step.models import Step


class HomeView(LoginRequiredMixin, TemplateView):

    template_name = "dashboard/pages/home.html"

    page_name = 'Dashboard'


    def get_context_data(self, **kwargs):

        context = super().get_context_data(**kwargs)

        context['profile_progress'] = Profile.objects.profile_progress(self.request.user)

        context['profile_progress_num'] = 11

        # Returns False if the profile is in progress otherwise True
        context['profile_status'] = Step.objects.profile_status(self.request.user)

        context["apps"] = Application.objects.filter(user = self.request.user)

        context['applications_count'] = Application.objects.applications_count(self.request.user)

        context['completed_applications_count'] = Step.objects.completed_applications_count(self.request.user)

        context['percentage_of_completed_applications'] = Step.objects.percentage_of_completed_applications(self.request.user)

        # Returns list of the tuples that contain SKU of application and percentage of completed application fields
        context['applications_progress'] = Application.objects.applications_progress(self.request.user)
        
        context["projects"] = Project.objects.projects(self.request.user)

        context["projects_count"] = Project.objects.projects_count(self.request.user)

        context['completed_projects_count'] = Step.objects.completed_projects_count(self.request.user)

        context['percentage_of_completed_projects'] = Step.objects.percentage_of_completed_projects(self.request.user)

        # Returns list of the tuples that contain SKU of project and percentage of completed project fields
        context['projects_progress'] = Project.objects.projects_progress(self.request.user)

        context["tickets"] = Ticket.objects.filter(raised_by = self.request.user)

        context["ticket_count"] = Ticket.objects.ticket_count(self.request.user)
        
        context["answered_ticket_count"] = Ticket.objects.answered_ticket_count(self.request.user)

        context["unanswered_ticket_count"] = Ticket.objects.unanswered_ticket_count(self.request.user)
        
        # List of applications that have not completed all steps
        context["inprogress_requests"] = Step.objects.inprogress_requests(self.request.user)

        # Number of applications that have not completed all steps +
        # if profile is not completed
        context["inprogress_requests_count"] = Step.objects.inprogress_requests_count(self.request.user)

        # List of applications that is completed all steps
        context["complete_requests"] = Step.objects.completed_requests(self.request.user)
        
        # Number of applications that is completed all steps +
        # if profile is completed
        context["complete_requests_count"] = Step.objects.completed_requests_count(self.request.user)

        context['whole_process'] = Step.objects.whole_process(self.request.user)

        return context

project/views.py
from project.subviews.application import (
    ApplicationCreateView,
    ApplicationListView,
    ApplicationView,
    ApplicationFinalizeView,
)

from project.subviews.project import (
    ProjectTemplateView,
    ProjectView,
    ProjectFinalizeView,
    ProjectShownView,
)

from project.subviews.team import (
    TeamMemberView,
    TeamPublishedView
)

media/templates/dashboard/pages/application-project-edit.html
{% extends 'shared/_dashboard.html' %}
{% load static %}
{% load widget_tweaks %}



{% block body %}
<div class="container-fluid">
    <div class="row">
        <div class="col-12">

            <h1>Account Management</h1>
            <nav class="breadcrumb-container d-none d-sm-block d-lg-inline-block" aria-label="breadcrumb">
                <ol class="breadcrumb pt-0">
                    <li class="breadcrumb-item">
                        {% comment %} <a href="{% url 'dashboard:home' %}">Home</a> {% endcomment %}
                        <a href="#">Home</a>
                    </li>
                    <li class="breadcrumb-item">
                        <a href="{% url 'dashboard:application-list' %}">Applications </a>
                    </li>
                    <li class="breadcrumb-item">
                        <a href="{% url 'dashboard:application-edit' project.application.sku %}">Application ID
                            {{ project.application.sku|truncatechars:10 }} </a>
                    </li>
                    <li class="breadcrumb-item active" aria-current="page">Project ID [ {{ project.sku }} ]</li>
                </ol>
            </nav>
            <div class="separator mb-5"></div>


        </div>
    </div>

    <div class="row">
        <div class="col-12 col-lg-12 mb-5">

            <div class="card mb-4">
                <div class="card-body">
                    <h5 class="mb-4" style="float: left;">Project Modification</h5>
                    {% if messages %}
                    {% for message in messages %}
                    {% if 'error' in message.tags %}
                    <div class="alert alert-danger">
                        {% else %}
                        <div class="alert alert-{{ message.tags }}">
                            {% endif %}
                            <li {% if message.tags %}class="{{ message.tags }}" {% endif %}>{{ message }}</li>
                        </div>
                        {% endfor %}
                        {% endif %}

                        {% if form.errors %}
                        <div class="alert alert-danger">
                            {{ form.errors }}
                        </div>
                        {% endif %}

                                {% comment %} action="{% url 'dashboard:application-project-published' project.application.sku project.sku %}"> {% endcomment %}
                        {% if not project.is_published %}
                        <div style="float: right;">
                            <form method="POST"
                                id="project-published"
                                action="#">
                                {% csrf_token %}
                                <input type="hidden" name="g-recaptcha-response" id='recaptcha'>
                                <input type="hidden" name="is_published" class="form-control invisible" value='true' />
                                <button type="submit" class="btn btn-danger btn-lg">Finalize your Project</button>
                            </form>
                        </div>
                        <div class="clearfix"></div>
                        {% else %}
                                {% comment %} action="{% url 'dashboard:application-project-shown' project.application.sku project.sku %}"> {% endcomment %}
                        <div style="float: right;">
                            <form method="POST"
                                id="project-shown"
                                action="#">
                                {% csrf_token %}
                                <input type="hidden" name="g-recaptcha-response" id='recaptcha'>
                                {% if project.is_shown %}
                                    <input type="hidden" name="is_shown" class="form-control invisible" value='false' />
                                    <button type="submit" class="btn btn-info btn-lg">Hidden Project on site</button>
                                {% else %}
                                    <input type="hidden" name="is_shown" class="form-control invisible" value='true' />
                                    <button type="submit" class="btn btn-info btn-lg">Show Project from site</button>
                                {% endif %}

                            </form>
                        </div>
                        <div class="clearfix"></div>
                        {% endif %}

                        <hr />
                        {% if not project.is_published %}

                        <form method="POST" enctype="multipart/form-data" class="tooltip-label-right"
                            id="project-draft"
                            action="{% url 'dashboard:application-project-edit' project.application.sku project.sku %}">
                            {% csrf_token %}
                            <input type="hidden" name="g-recaptcha-response" id='recaptcha'>

                            <div class="form-group position-relative error-l-50">
                                <label>{{ form.title.label }}</label>
                                {% render_field form.title class="form-control"  %}

                                <div class="invalid-tooltip">
                                    {{ form.title.label }} is required!
                                </div>
                            </div>

                            <label>{{ form.summary.label }}</label>
                            <div class="form-group position-relative error-l-50">
                                {% render_field form.summary class="form-control"  %}

                                <div class="invalid-tooltip">
                                    {{ form.summary.label }} is required!
                                </div>
                            </div>

                            <label>{{ form.content.label }}</label>
                            <div class="form-group position-relative error-l-50">
                                {% render_field form.content class="form-control"  %}

                                <div class="invalid-tooltip">
                                    {{ form.content.label }} is required!
                                </div>
                            </div>

                            <div class="form-group position-relative error-l-50">
                                <label>{{ form.cover.label }}</label>
                                {% render_field form.cover class="form-control"  %}

                                <div class="invalid-tooltip">
                                    {{ form.cover.label }} is required!
                                </div>
                            </div>

                            <div class="btn-group mr-2 mb-1" role="group">
                                <button type="submit" class="btn btn-outline-primary ">Save</button>
                                {% comment %} <a class="btn btn-outline-info " href="{% url 'dashboard:project-view' project.application.sku project.sku %}">Preview</a> {% endcomment %}
                                <a class="btn btn-outline-info " href="#">Preview</a>
                            </div>
                            
                            
                        </form>

                        {% else %}

                        <h5>Title</h5>
                        <div class="form-group position-relative">
                            <input type="text" disabled="disabled" class="form-control" value={{ project.title }}>
                        </div>


                        <a href="{% url 'dashboard:project-view' project.application.sku project.sku %}">Preview Design
                            of project</a>


                        {% endif %}


                    </div>
                </div>
            </div>
        </div>

    </div>

    {% endblock %}



    {% block scripts %}
    <script>
        window.CKEDITOR_BASEPATH = '/static/ckeditor/ckeditor/';
    </script>
    <script src="{% static 'assets/dashboard/js/vendor/ckeditor5-build-classic/ckeditor.js' %}"></script>

    <script type="text/javascript" src="{% static 'ckeditor/ckeditor-init.js' %}"></script>
    <script type="text/javascript" src="{% static 'ckeditor/ckeditor/ckeditor.js' %}"></script>

    <script src="https://www.google.com/recaptcha/api.js?render=6LfZsvgUAAAAAJX02IjM58aIqO5y-g60SRJGPR4A"></script>
    <script>
        grecaptcha.ready(function() {
            $('#project-draft').submit(function(e){
                var form = this;
                e.preventDefault()
                grecaptcha.execute('6LfZsvgUAAAAAJX02IjM58aIqO5y-g60SRJGPR4A', {action: 'recaptcha'}).then(function(token) {
                    $('#recaptcha').val(token)
                    form.submit()
                });
            })

        });
    </script>
    <script>
        grecaptcha.ready(function() {
            $('#project-published').submit(function(e){
                var form = this;
                e.preventDefault()
                grecaptcha.execute('6LfZsvgUAAAAAJX02IjM58aIqO5y-g60SRJGPR4A', {action: 'recaptcha'}).then(function(token) {
                    $('#recaptcha').val(token)
                    form.submit()
                });
            })

        });
    </script>
    <script>
        grecaptcha.ready(function() {
            $('#project-shown').submit(function(e){
                var form = this;
                e.preventDefault()
                grecaptcha.execute('6LfZsvgUAAAAAJX02IjM58aIqO5y-g60SRJGPR4A', {action: 'recaptcha'}).then(function(token) {
                    $('#recaptcha').val(token)
                    form.submit()
                });
            })

        });
    </script>
    {% endblock %}

media/templates/dashboard/pages/project.html
{% extends 'shared/_dashboard.html' %}
{% load static %}
{% load widget_tweaks %}

{% block styles %}
<style type="text/css">
    
.deneb-responsive {
    width: 100% !important;
    height: 100% !important;
}
</style>
{% endblock %}

{% block body %}
<div class="container-fluid">
    <div class="row">
        <div class="col-12">

            <h1>Account Management</h1>
            <nav class="breadcrumb-container d-none d-sm-block d-lg-inline-block" aria-label="breadcrumb">
                <ol class="breadcrumb pt-0">
                    <li class="breadcrumb-item">
                        {% comment %} <a href="{% url 'dashboard:home' %}">Home</a> {% endcomment %}
                        <a href="#">Home</a>
                    </li>
                    <li class="breadcrumb-item">
                        <a href="{% url 'dashboard:application-list' %}">Applications </a>
                    </li>
                    <li class="breadcrumb-item">
                        <a href="{% url 'dashboard:application-edit' project.application.sku %}">Application ID
                            {{ project.application.sku|truncatechars:10 }} </a>
                    </li>
                    <li class="breadcrumb-item">
                        {% comment %} <a href="{% url 'dashboard:application-project-edit' project.application.sku project.sku %}">Project ID  {% endcomment %}
                        <a href="#">Project ID 
                            {{ project.sku|truncatechars:10 }} </a>
                    </li>
                    <li class="breadcrumb-item active" aria-current="page">Preview</li>
                </ol>
            </nav>
            <div class="separator mb-5"></div>
        </div>
    </div>
    <div class="row">
        <div class="col-12 col-md-12 col-xl-8 col-left">
            <div class="card mb-4">
                <div class="lightbox">
                    <a href="#">
                    {% if project.cover %}
                        <img alt="detail" src="{{project.cover.url}}" class="responsive border-0 card-img-top mb-3" />
                    {% else %}
                        <img src="https://via.placeholder.com/1024" alt="{{ project.title }}" class="responsive border-0 card-img-top mb-3" />

                    {% endif %}
                        
                    </a>
                </div>
                <div class="card-body">
                    <div class="ck-responsive-img mb-5">
                        <h2 class="card-title">{{project.title}}</h2>
                        {{project.summary|safe}}
                        {{project.content|safe}}
                    </div>


                </div>
            </div>
        </div>

        <div class="col-12 col-md-12 col-xl-4 col-right">

            <div class="card mb-4">
                <div class="card-body">
                    <h5 class="card-title">Application Process</h5>


                    <div class="container">
                        <div class="billing__main__content__step ">
                            <ul id="step-list">
                                {% for step in project.application.steps.all %}
                                    <li class="option {% if step.state == 'c' %}active{% endif %}"
                                        for="{{ step.get_step_display }}" data-step="{{ forloop.counter }}">
                                        <a href="#">
                                            <span class="default"><i
                                                    class="fa fa-{% if step.state == 'c' %}user{% else %}envelope{% endif %}"
                                                    aria-hidden="true"></i></span>
                                            <span class="done-icon"><i class="fa fa-check" aria-hidden="true"></i></span>
                                            <p>{{ step.get_step_display  }}</p>
                                        </a>
                                    </li>
                                {% endfor %}
                            </ul>
                        </div>
                    </div>




                </div>





            </div>
        </div>
    </div>
</div>
{% endblock %}
</body>

</html>